



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Struts2(二)工作原理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Struts2(二)工作原理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 13:31:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>一、概述</h3>
<p>1、struts框架本身分为三个部分：核心控制器FilterDispatcher、业务控制器Action和用户实现的企业业务逻辑组件。</p>
<p>2、struts2工作的基本流程：</p>
<ul><li>客户端初始化一个指向Servlet容器的请求</li>
<li>org.apache.struts2.dispatcher.ng.filter.StrutsPrepareAndExecuteFilter被调用，该过滤器询问ActionMaper这个请求是否需要调用某个Action</li>
<li>如果ActionMapper决定需要调用某个Action，StrutsPrepareAndExecuteFilter把请求的处理交给ActionProxy</li>
<li>ActionProxy通过Configuration Manager询问框架的配置文件，找到需要调用的Action类</li>
<li>ActionProxy创建一个ActionProxy的实例</li>
<li>ActionProxy实例使用命名模式来调用</li>
<li>一旦Action执行完毕，ActionInvocation负责根据struts.xml中的配置找到对应的返回结果</li></ul>
<h3>二、源码分析</h3>
<p>　　下面解析org.apache.struts2.dispatcher.ng.filter.StrutsPrepareAndExecuteFilter类</p>
<div>
<pre class="prettyprint linenums"> public class StrutsPrepareAndExecuteFilter implements StrutsStatics, Filter<br />
 {<br />
     /*<br />
      * prepareOperation对象包含执行请求之前的准备工作<br />
      * ExecuteOperations对象包含过滤器的执行操作<br />
      */<br />
     protected PrepareOperations prepare;<br />
     protected ExecuteOperations execute;<br />
     protected List&lt;Pattern&gt; excludedPatterns = null;

     public void init(FilterConfig filterConfig) throws ServletException<br />
     {<br />
         //InitOperations类包含一些初始化操作<br />
         InitOperations init = new InitOperations();<br />
         Dispatcher dispatcher = null;<br />
         try<br />
         {<br />
             //封装filterConfig，其中有个主要方法getInitParameterNames将参数名字以String格式存储在List中<br />
             FilterHostConfig config = new FilterHostConfig(filterConfig);<br />
             //初始化struts内部日志<br />
             init.initLogging(config);<br />
             //创建dispatcher ，并初始化<br />
             dispatcher = init.initDispatcher(config);<br />
             init.initStaticContentLoader(config, dispatcher);<br />
             //初始化类属性：prepare 、execute<br />
             prepare = new PrepareOperations(dispatcher);<br />
             execute = new ExecuteOperations(dispatcher);<br />
             this.excludedPatterns = init.buildExcludedPatternsList(dispatcher);<br />
             //回调空的postInit方法<br />
             postInit(dispatcher, filterConfig);<br />
         }<br />
         finally<br />
         {<br />
             if (dispatcher != null) {<br />
                 dispatcher.cleanUpAfterInit();<br />
             }<br />
             init.cleanup();<br />
         }<br />
     }<br />
     /**<br />
      * Callback for post initialization<br />
      */<br />
     protected void postInit(Dispatcher dispatcher, FilterConfig filterConfig)<br />
     {<br />
     }

     public void doFilter(ServletRequest req, ServletResponse res, FilterChain chain) throws IOException, ServletException<br />
     {<br />
         HttpServletRequest request = (HttpServletRequest) req;<br />
         HttpServletResponse response = (HttpServletResponse) res;<br />
         try<br />
         {<br />
             if (excludedPatterns != null &amp;&amp; prepare.isUrlExcluded(request, excludedPatterns))<br />
             {<br />
                 //过滤器放行<br />
                 chain.doFilter(request, response);<br />
             }<br />
             else<br />
             {<br />
                 //设置编码国际化和地点<br />
                 prepare.setEncodingAndLocale(request, response);<br />
                 //创建action上下文<br />
                 //ActionContext是一个线程的本地变量，这意味着不同的action之间不会共享ActionContext，所以也不用考虑线程安全问题<br />
                 prepare.createActionContext(request, response);<br />
                 prepare.assignDispatcherToThread();<br />
                 request = prepare.wrapRequest(request);<br />
                 ActionMapping mapping = prepare.findActionMapping(request, response, true);<br />
                 //如果mapping为空，则认为不是调用action,会调用下一个过滤器链，直到获取到mapping才调用action<br />
                 if (mapping == null)<br />
                 {<br />
                     boolean handled = execute.executeStaticResourceRequest(request, response);<br />
                     if (!handled)<br />
                     {<br />
                         chain.doFilter(request, response);<br />
                     }<br />
                 }<br />
                 else<br />
                 {<br />
                     //执行action<br />
                     execute.executeAction(request, response, mapping);<br />
                 }<br />
             }<br />
         }<br />
         finally<br />
         {<br />
             prepare.cleanupRequest(request);<br />
         }<br />
     }<br />
     public void destroy() {<br />
         prepare.cleanupDispatcher();<br />
     }<br />
 }</pre>
</div>
<p>　　上述源码的第23行：dispatcher = init.initDispatcher(config);</p>
<div>
<pre class="prettyprint linenums">//创建并初始化Dispatcher对象<br />
    public Dispatcher initDispatcher( HostConfig filterConfig ) <br />　　{<br />
        Dispatcher dispatcher = createDispatcher(filterConfig);<br />
        dispatcher.init();<br />
        return dispatcher;<br />
    }</pre>
</div>
<p>　　创建dispatcher，会读取 filterConfig 中的配置信息，将配置信息解析出来，封装成为一个Map，然后根绝servlet上下文和参数Map构造Dispatcher ：</p>
<div>
<pre class="prettyprint linenums"> private Dispatcher createDispatcher( HostConfig filterConfig )<br />
 {<br />
        Map&lt;String, String&gt; params = new HashMap&lt;String, String&gt;();<br />
        for(Iterator e = filterConfig.getInitParameterNames(); e.hasNext(); )<br />
　　　　　　{<br />
            String name = (String) e.next();<br />
            String value = filterConfig.getInitParameter(name);<br />
            params.put(name, value);<br />
         }<br />
        return new Dispatcher(filterConfig.getServletContext(), params);<br />
 }</pre>
</div>
<p>　　初始化dispatcher过程如下：</p>
<div>
<pre class="prettyprint linenums">public void init()<br />
{<br />
    if (configurationManager == null)<br />
        {<br />
           configurationManager = createConfigurationManager(DefaultBeanSelectionProvider.DEFAULT_BEAN_NAME);<br />
        }<br />
         //初始化过程中，会加载一些配置文件，例如：default.properties,struts-default.xml,struts-plugin.xml,struts.xml等<br />
       try<br />
           {<br />
           init_FileManager();<br />
           init_DefaultProperties(); // [1]<br />
           init_TraditionalXmlConfigurations(); // [2]<br />
           init_LegacyStrutsProperties(); // [3]<br />
           init_CustomConfigurationProviders(); // [5]<br />
           init_FilterInitParameters() ; // [6]<br />
           init_AliasStandardObjects() ; // [7]<br />
           Container container = init_PreloadConfiguration();<br />
           container.inject(this);<br />
           init_CheckWebLogicWorkaround(container);<br />
           if (!dispatcherListeners.isEmpty())<br />
           {<br />
               for (DispatcherListener l : dispatcherListeners)<br />
               {<br />
                   l.dispatcherInitialized(this);<br />
               }<br />
           }<br />
           errorHandler.init(servletContext);<br />
       }<br />
       catch (Exception ex)<br />
       {<br />
           if (LOG.isErrorEnabled())<br />
               LOG.error("Dispatcher initialization failed", ex);<br />
           throw new StrutsException(ex);<br />
       }<br />
}</pre>
</div>
<p>　　上述分析的是StrutsPrepareAndExecuteFilter类的init方法，该方法在web容器启动的时候就会被调用，当用户访问某个action时，首先调用StrutsPrepareAndExecuteFilter类的doFilter方法，下面具体分析下这个方法：</p>
<ul><li>首先是设置编码格式和地点：</li></ul>
<p>　　prepare.setEncodingAndLocale(request, response);</p>
<ul><li>创建ActionContext，ActionContext(com.opensymphony.xwork.ActionContext)是Action执行时的上下文,上下文可以看作是一个容器(其实我们这里的容器就是一个Map而已),它存放的是Action在执行时需要用到的对象，比如Session、Application、Request、Locale、ValueStack等。</li></ul>
<p>　　&nbsp;prepare.createActionContext(request, response);</p>
<ul><li>分配调度到本地线程调度</li></ul>
<p>　　&nbsp; prepare.assignDispatcherToThread();</p>
<ul><li>request进行包装，如果content_type是multipart/form-data类型，则将request包装成MultiPartRequestWrapper对象，否则包装成StrutsRequestWrapper对象</li></ul>
<div>
<pre class="prettyprint linenums"> request = prepare.wrapRequest(request);</pre>
</div>
<div>
<pre class="prettyprint linenums">public HttpServletRequest wrapRequest(HttpServletRequest request) throws IOException<br />
{<br />
    // don't wrap more than once<br />
    if (request instanceof StrutsRequestWrapper)<br />
    {<br />
        return request;<br />
    }<br />
    String content_type = request.getContentType();<br />
    if (content_type != null &amp;&amp; content_type.contains("multipart/form-data"))<br />
    {<br />
        MultiPartRequest mpr = getMultiPartRequest();<br />
        LocaleProvider provider = getContainer().getInstance(LocaleProvider.class);<br />
        request = new MultiPartRequestWrapper(mpr, request, getSaveDir(), provider, disableRequestAttributeValueStackLookup);<br />
    }<br />
    else<br />
    {<br />
        request = new StrutsRequestWrapper(request, disableRequestAttributeValueStackLookup);<br />
    }<br />
    return request;<br />
}</pre>
</div>
<ul><li>然后通过ActionMapper的getMapping()方法得到请求的Action，Action的配置信息存储在ActionMapping对象中，</li></ul>
<p>　　ActionMapping mapping = prepare.findActionMapping(request, response, true);</p>
<p>　　我们找到prepare对象的findActionMapping方法：</p>
<div>
<pre class="prettyprint linenums">public ActionMapping findActionMapping(HttpServletRequest request, HttpServletResponse response, boolean forceLookup)<br />
{<br />
    //首先从request对象中取mapping对象，看是否存在<br />
    ActionMapping mapping = (ActionMapping) request.getAttribute(STRUTS_ACTION_MAPPING_KEY); //struts.actionMapping<br />
    //不存在就创建一个<br />
    if (mapping == null || forceLookup)<br />
    {<br />
        try<br />
        {<br />
            //首先创建ActionMapper对象，通过ActionMapper对象创建mapping对象<br />
            mapping = dispatcher.getContainer().getInstance(ActionMapper.class).getMapping(request, dispatcher.getConfigurationManager());<br />
            if (mapping != null)<br />
            {<br />
                request.setAttribute(STRUTS_ACTION_MAPPING_KEY, mapping);<br />
            }<br />
        } catch (Exception ex) {<br />
            dispatcher.sendError(request, response, HttpServletResponse.SC_INTERNAL_SERVER_ERROR, ex);<br />
        }<br />
    }<br />
    return mapping;<br />
}</pre>
</div>
<p>　　ActionMapper接口的实现类DefaultActionMapper的getMapping()方法的源代码：</p>
<div>
<pre class="prettyprint linenums">public ActionMapping getMapping(HttpServletRequest request, ConfigurationManager configManager)<br />
{<br />
          ActionMapping mapping = new ActionMapping();<br />
          //获得请求的uri，即请求路径URL中工程名以后的部分，如/HelloWorld.action<br />
          String uri = getUri(request);<br />
          int indexOfSemicolon = uri.indexOf(";");<br />
          uri = (indexOfSemicolon &gt; -1) ? uri.substring(0, indexOfSemicolon) : uri;<br />
          //删除扩展名，如.action或者.do<br />
          uri = dropExtension(uri, mapping);<br />
          if (uri == null)<br />
          {<br />
             return null;<br />
          }<br />
         //从uri中分离得到请求的action名、命名空间。<br />
         parseNameAndNamespace(uri, mapping, configManager);<br />
         //处理特殊的请求参数<br />
         handleSpecialParameters(request, mapping);<br />
         //如果允许动态方法调用，即形如/HelloWorldAction!getAll.action的请求，分离action名和方法名<br />
         return parseActionName(mapping);<br />
}</pre>
</div>
<ul><li>如果mapping为空，则认为不是调用action,会调用下一个过滤器链，直到获取到mapping才调用action</li></ul>
<div>
<pre class="prettyprint linenums">if (mapping == null)<br />
   {<br />
      boolean handled = execute.executeStaticResourceRequest(request, response);<br />
      if (!handled)<br />
         {<br />
            chain.doFilter(request, response);<br />
         }<br />
   } </pre>
</div>
<ul><li>如果mapping对象不为空，则会执行action</li></ul>
<p>　　 execute.executeAction(request, response, mapping);</p>
<p>　　其源码为：</p>
<div>
<pre class="prettyprint linenums">public void serviceAction(HttpServletRequest request, HttpServletResponse response, ActionMapping mapping) throws ServletException <br />{<br />
        //封转上下文环境，主要将requestMap、params、session等Map封装成为一个上下文Map<br />
        Map&lt;String, Object&gt; extraContext = createContextMap(request, response, mapping);<br />
        // If there was a previous value stack, then create a new copy and pass it in to be used by the new Action<br />
        ValueStack stack = (ValueStack) request.getAttribute(ServletActionContext.STRUTS_VALUESTACK_KEY);<br />
        boolean nullStack = stack == null;<br />
        if (nullStack)<br />
        {<br />
            ActionContext ctx = ActionContext.getContext();<br />
            if (ctx != null)<br />
            {<br />
                stack = ctx.getValueStack();<br />
            }<br />
        }<br />
        if (stack != null)<br />
        {<br />
            extraContext.put(ActionContext.VALUE_STACK, valueStackFactory.createValueStack(stack));<br />
        }<br />
        String timerKey = "Handling request from Dispatcher";<br />
        try<br />
        {<br />
            UtilTimerStack.push(timerKey);<br />
            String namespace = mapping.getNamespace();//从mapping对象获取命名空间<br />
            String name = mapping.getName(); //获取请求的action名<br />
            String method = mapping.getMethod(); //获取请求方法

          //根据执行上下文参数，命名空间，名称等创建用户自定义Action的代理对象<br />
            ActionProxy proxy = getContainer().getInstance(ActionProxyFactory.class).createActionProxy(<br />
                    namespace, name, method, extraContext, true, false);

            request.setAttribute(ServletActionContext.STRUTS_VALUESTACK_KEY, proxy.getInvocation().getStack());

          //如果配置文件中执行的这个action配置了result，就直接转到result<br />
            if (mapping.getResult() != null)<br />
            {<br />
                Result result = mapping.getResult();<br />
                result.execute(proxy.getInvocation());<br />
            }<br />
            else<br />
            {<br />
                proxy.execute();<br />
            }

            // If there was a previous value stack then set it back onto the request<br />
            if (!nullStack) {<br />
                request.setAttribute(ServletActionContext.STRUTS_VALUESTACK_KEY, stack);<br />
            }<br />
        }<br />
        catch (ConfigurationException e)<br />
        {<br />
            logConfigurationException(request, e);<br />
            sendError(request, response, HttpServletResponse.SC_NOT_FOUND, e);<br />
        }<br />
        catch (Exception e)<br />
        {<br />
            if (handleException || devMode)<br />
            {<br />
                sendError(request, response, HttpServletResponse.SC_INTERNAL_SERVER_ERROR, e);<br />
            }<br />
            else<br />
            {<br />
                throw new ServletException(e);<br />
            }<br />
        }<br />
        finally<br />
        {<br />
            UtilTimerStack.pop(timerKey);<br />
        }<br />
    }<br />
}</pre>
</div>
<ul><li>最后通过Result完成页面跳转。</li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m963lv94.html">缓存、队列（Memcached、redis、RabbitMQ）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2mlyw8.html">Linux下面配置文件~&sol;&period;bash&lowbar;profile</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r032e9.html">AseBulkCopy 若干问题的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kzoo78.html">lua库函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyerxg9.html">20145317彭垚 《Java程序设计》第一次实验实验报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1k0k79.html">HBase-java api 基本操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn4njj8.html">使MySQL 支持繁体字</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k14pzj9.html">查看java的&period;class文件的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mynweq.html">网络流&lpar;最大费用最大流&rpar; ：POJ 3680 Intervals</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd2z1l8.html">Css的三大机制（特性）：特殊性、继承、层叠详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y00djq.html">蚁群算法matlab实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jwl7x8.html">uva &colon;10123 - No Tipping（dfs &plus; 几何力矩 ）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv11mpxq.html">CloudFoundry&period;yml修订</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjgzp28.html">JS中关于数组的内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzw3ve8.html">Linux（Centos7）下搭建SVN服务器  &lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zxmg39.html">MIUI9 解锁并刷入TWRP后，删除解锁密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/95grmzvq.html">python cookbook 小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy27vjq.html">word 2013 题注、图注、插入图片自动修改大小、批量更新题注编号</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllv111q.html">Dalvik虚拟机执行流程图</a>
		</li>
						<li><a href="https://www.batexi.com/a/960vg2y9.html">urllib模块学习</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qx22ree8.html">【转】Visual Studio团队资源管理器 Git 源码管理工具简单入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/8koo6y5q.html">e812&period; 强制弹出菜单为重组件</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pp1708.html">嵌入式开发之zynq---Zynq PS侧DMA驱动</a>
			</li>
						<li><a href="https://www.batexi.com/a/9633n449.html">&lpar;转&rpar;PCM数据格式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwllmjz9.html">成都传智播客java就业班（14&period;04&period;01班）就业快报（Java程序猿薪资一目了然）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmm41e9.html">C&num;绘制数字图像灰度直方图</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emmvlj9.html">linux任务计划 chkconfig工具  systemd管理服务  unit介绍 target介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vv362q.html">使用w查看系统负载  vmstat命令 top命令  sar命令  nload命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/9633een9.html">Mac下给SD卡烧录树莓派系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjj0308.html">Spring定时器的两种实现方式</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
